<?php
namespace Folha\Repositories;

class FpaFerias extends \Doctrine\ORM\EntityRepository
{
    public static function getPeriodoGozoFerias($nrvinculom, \DateTime $dtinicio,\DateTime $dtfinal, $nrorg)
    {
        $dtinicio = $dtinicio->format('d/m/Y');
        $dtfinal = $dtfinal->format('t/m/Y');

        $sql = <<<SQL
SELECT FPA_FERIAS.NRORG,
    FPA_FERIAS.NRVINCULOM,
    FPA_GOZOFERIAS.DTINIGOZOFERIAS,
    FPA_GOZOFERIAS.DTFIMGOZOFERIAS,
    (CASE
        WHEN (FPA_GOZOFERIAS.DTINIGOZOFERIAS<TO_DATE('$dtinicio')) AND (FPA_GOZOFERIAS.DTFIMGOZOFERIAS<TO_DATE('$dtfinal'))
            THEN FPA_GOZOFERIAS.DTFIMGOZOFERIAS-TO_DATE('$dtinicio')+1
        WHEN (FPA_GOZOFERIAS.DTINIGOZOFERIAS>TO_DATE('$dtinicio')) AND (FPA_GOZOFERIAS.DTFIMGOZOFERIAS>TO_DATE('$dtfinal'))
            THEN TO_DATE('$dtfinal')+1 - FPA_GOZOFERIAS.DTINIGOZOFERIAS
        WHEN (FPA_GOZOFERIAS.DTINIGOZOFERIAS>TO_DATE('$dtinicio')) AND (FPA_GOZOFERIAS.DTFIMGOZOFERIAS<TO_DATE('$dtfinal'))
            THEN FPA_GOZOFERIAS.DTFIMGOZOFERIAS-FPA_GOZOFERIAS.DTINIGOZOFERIAS+ 1
    END)QUANTIDADE
FROM FPA_FERIAS
INNER JOIN FPA_GOZOFERIAS
    ON FPA_GOZOFERIAS.NRFERIAS = FPA_FERIAS.NRFERIAS
    AND FPA_GOZOFERIAS.NRORG = FPA_FERIAS.NRORG
WHERE (FPA_GOZOFERIAS.DTINIGOZOFERIAS BETWEEN TO_DATE('$dtinicio')-1 AND '$dtfinal'
    OR FPA_GOZOFERIAS.DTFIMGOZOFERIAS BETWEEN TO_DATE('$dtinicio')-1 AND '$dtfinal')
    AND FPA_FERIAS.NRVINCULOM = $nrvinculom
    AND FPA_FERIAS.NRORG = $nrorg
SQL;

        //$result = \Setforms2\Shared\Connection::getInstance()->fetchAll($sql);
        $query = \Setforms2\Shared\Registry::getEntityManager()->getConnection()->prepare($sql);
        $query->execute();
        $result = $query->fetchAll();
        if($result)
            return $result[0];
        else
            return false;
    }
    
    public static function getPeriodoGozoFeriasVt($nrvinculom, \DateTime $dtinicio,\DateTime $dtfinal, $nrorg)
    {#01/11 - 19/11 -> 21/11
    #11/11 - 30/11 -> 21/11
        $dtinicio = $dtinicio->format('d/m/Y');
        $dtfinal = $dtfinal->format('d/m/Y');

        $sql = <<<SQL
SELECT FPA_FERIAS.NRORG,
    FPA_FERIAS.NRVINCULOM,
    FPA_GOZOFERIAS.DTINIGOZOFERIAS,
    FPA_GOZOFERIAS.DTFIMGOZOFERIAS,
    (CASE
        WHEN (FPA_GOZOFERIAS.DTINIGOZOFERIAS<TO_DATE('$dtinicio')) AND (FPA_GOZOFERIAS.DTFIMGOZOFERIAS<TO_DATE('$dtfinal'))
            THEN FPA_GOZOFERIAS.DTFIMGOZOFERIAS-TO_DATE('$dtinicio')+1
        WHEN (FPA_GOZOFERIAS.DTINIGOZOFERIAS>TO_DATE('$dtinicio')) AND (FPA_GOZOFERIAS.DTFIMGOZOFERIAS>TO_DATE('$dtfinal'))
            THEN TO_DATE('$dtfinal')+1 - FPA_GOZOFERIAS.DTINIGOZOFERIAS
        WHEN (FPA_GOZOFERIAS.DTINIGOZOFERIAS>TO_DATE('$dtinicio')) AND (FPA_GOZOFERIAS.DTFIMGOZOFERIAS<TO_DATE('$dtfinal'))
            THEN FPA_GOZOFERIAS.DTFIMGOZOFERIAS-FPA_GOZOFERIAS.DTINIGOZOFERIAS+ 1
    END)QUANTIDADE
FROM FPA_FERIAS
INNER JOIN FPA_GOZOFERIAS
    ON FPA_GOZOFERIAS.NRFERIAS = FPA_FERIAS.NRFERIAS
    AND FPA_GOZOFERIAS.NRORG = FPA_FERIAS.NRORG
WHERE (FPA_GOZOFERIAS.DTINIGOZOFERIAS BETWEEN TO_DATE('$dtinicio')-1 AND '$dtfinal'
    OR FPA_GOZOFERIAS.DTFIMGOZOFERIAS BETWEEN TO_DATE('$dtinicio')-1 AND '$dtfinal')
    AND FPA_FERIAS.NRVINCULOM = $nrvinculom
    AND FPA_FERIAS.NRORG = $nrorg
SQL;

        //$result = \Setforms2\Shared\Connection::getInstance()->fetchAll($sql);
        $query = \Setforms2\Shared\Registry::getEntityManager()->getConnection()->prepare($sql);
        $query->execute();
        $result = $query->fetchAll();
        if($result)
            return $result[0];
        else
            return false;
    }

}