/**
 * Insere registros na tabela LOGOPERA a partir de alteraes na tabela INTECLIE.
 *
 * @author Ederson Melquades da Cunha <ederson@teknisa.com>
 */

CREATE OR REPLACE TRIGGER LOG_GER_INTECLIE
AFTER UPDATE OR INSERT OR DELETE
ON INTECLIE FOR EACH ROW
DECLARE
   V_DSREMOTEADDR VARCHAR2(15);
   V_DSREMOTEHOST VARCHAR2(15);
   V_DSSERVERRDM VARCHAR2(20);
   V_DSSERVMETHOD VARCHAR2(30);
   V_DSREMOTEOPER VARCHAR2(12);
   V_DESC VARCHAR2(2000);
   V_ITPESQ VARCHAR2(40);
   V_NMOPERADOR VARCHAR2(40);
   V_IDTPINTECLIE VARCHAR2(100);
   V_IDINTERRECPRES VARCHAR2(100);
   V_IDENVEMAILINTFA VARCHAR2(100);
   V_IDTIPOOPER VARCHAR2(1);
   V_IDENDEINCLIE VARCHAR2(100);
   V_IDSTINTECLIE VARCHAR2(100);
   V_NRINSJURCLIE CLIENTE.NRINSJURCLIE%TYPE;
   V_NMFANTCLIE CLIENTE.NMFANTCLIE%TYPE;
BEGIN
   /* ###############
      IDTIPOOPER
      '1' - INCLUSO
      '2' - ALTERAO
      '3' - EXCLUSO
      ###############
   */

   V_DSREMOTEADDR := ' ';
   V_DSREMOTEHOST := ' ';
   V_DSSERVERRDM := ' ';
   V_DSSERVMETHOD := ' ';
   V_DSREMOTEOPER := ' ';
   V_DESC := ' ';
   V_ITPESQ := ' ';
   V_NMOPERADOR := ' ';
   V_IDTIPOOPER := ' ';
   V_IDTPINTECLIE := ' ';
   V_IDENDEINCLIE := ' ';
   V_IDINTERRECPRES := ' ';

   NMUSUARIO(V_NMOPERADOR);
   WEBTUNNING(V_DSREMOTEADDR,
              V_DSREMOTEHOST,
              V_DSSERVERRDM,
              V_DSSERVMETHOD,
              V_DSREMOTEOPER);

   IF INSERTING OR UPDATING THEN
      SELECT NRINSJURCLIE, NMFANTCLIE
        INTO V_NRINSJURCLIE, V_NMFANTCLIE
        FROM CLIENTE
       WHERE CDCLIENTE = :NEW.CDCLIENTE;
   ELSE
      SELECT NRINSJURCLIE, NMFANTCLIE
        INTO V_NRINSJURCLIE, V_NMFANTCLIE
        FROM CLIENTE
       WHERE CDCLIENTE = :OLD.CDCLIENTE;
   END IF;

   IF INSERTING THEN
      IF :NEW.IDSTINTECLIE = 'A' OR :NEW.IDSTINTECLIE IS NULL THEN
         V_IDSTINTECLIE := '[Sit.ATIVO]';
      ELSE
         IF :NEW.IDSTINTECLIE = 'D' THEN
            V_IDSTINTECLIE := '[Sit.INATIVO]';
         END IF;
      END IF;

      IF :NEW.IDTPINTECLIE = 'P' THEN
         V_IDTPINTECLIE := '[PRESIDENTE]';
      ELSE
         IF :NEW.IDTPINTECLIE = 'D' THEN
            V_IDTPINTECLIE := '[DIRETOR]';
         ELSE
            IF :NEW.IDTPINTECLIE = 'G' THEN
               V_IDTPINTECLIE := '[GERENTE]';
            ELSE
               IF :NEW.IDTPINTECLIE = 'F' THEN
                  V_IDTPINTECLIE := '[FUNCIONRIO]';
               ELSE
                  IF :NEW.IDTPINTECLIE = 'O' THEN
                     V_IDTPINTECLIE := '[OUTROS]';
                  ELSE
                     IF :NEW.IDTPINTECLIE = 'S' THEN
                        V_IDTPINTECLIE := '[SUPERVISOR]';
                     ELSE
                        IF :NEW.IDTPINTECLIE = 'C' THEN
                           V_IDTPINTECLIE := '[COLABORADOR TEKNISA]';
                        ELSE
                           IF :NEW.IDTPINTECLIE = 'I' THEN
                              V_IDTPINTECLIE := '[SUPERINTENDENTE]';
                           ELSE
                              IF :NEW.IDTPINTECLIE = 'R' THEN
                                 V_IDTPINTECLIE := '[PROPRIETRIO]';
                              ELSE
                                 IF :NEW.IDTPINTECLIE = 'N' THEN
                                    V_IDTPINTECLIE := '[COORDENADOR]';
                                 END IF;
                              END IF;
                           END IF;
                        END IF;
                     END IF;
                  END IF;
               END IF;
            END IF;
         END IF;
      END IF;

      IF :NEW.IDENDEINCLIE = 'C' OR :NEW.IDENDEINCLIE IS NULL THEN
         V_IDENDEINCLIE := '[End.Comercial]';
      ELSE
         IF :NEW.IDENDEINCLIE = 'R' THEN
            V_IDENDEINCLIE := '[End.Residencial]';
         END IF;
      END IF;

      IF :NEW.IDINTERRECPRES = 'S' THEN
         V_IDINTERRECPRES := '[Presente: Sim]';
      ELSE
         IF :NEW.IDTPINTECLIE = 'R' THEN
            V_IDINTERRECPRES := '[Presente: No]';
         END IF;
      END IF;

      IF :NEW.IDENVEMAILINTFA = 'S' THEN
         V_IDENVEMAILINTFA := '[Email fat.atend.: Sim]';
      ELSE
         IF :NEW.IDTPINTECLIE = 'R' THEN
            V_IDENVEMAILINTFA := '[Email fat.atend.: No]';
         END IF;
      END IF;

      V_DESC := '[Cliente:' || V_NRINSJURCLIE || ' ' || V_NMFANTCLIE   || ']' ||
                '[Interloc:' || :NEW.CDINTECLIE || '-' ||:NEW.NMINTECLIE || ']' ||
                V_IDSTINTECLIE ||
                '[Cargo:' || :NEW.CDCARGOINTERLOC || ']' ||
                V_IDTPINTECLIE ||
                V_IDENDEINCLIE ||
                '[End:' || :NEW.DSENDEINCLIE || ']' ||
                '[Bairro:' || :NEW.NMBAIRINCLIE || ']' ||
                '[CEP:' || :NEW.NRCEPINCLIE || ']' ||
                '[Pas:' || :NEW.CDPAIS || ']' ||
                '[Estado:' || :NEW.SGESTADO || ']' ||
                '[Municpio:' || :NEW.CDMUNICIPIO || ']' ||
                '[Nasc.:' || TO_CHAR(:NEW.DTNASCINCLIE, 'FMDS') || ']' ||
                '[Tell:' || :NEW.NRTEL1INCLIE || ']' ||
                '[Ramal1:' || :NEW.NRRAM1INCLIE || ']' ||
                '[Tel2:' || :NEW.NRTEL2INCLIE || ']' ||
                '[Ramal2:' || :NEW.NRRAM2INCLIE || ']' ||
                '[Fax:' || :NEW.NRFAXINCLIE || ']' ||
                '[Cel:' || :NEW.NRCELULINCLI || ']' ||
                '[Resid:' || :NEW.NRTELREINCLI || ']' ||
                '[Email:' || :NEW.DSEMAILICLIE || ']' ||
                '[Func:' || :NEW.CDEMPRESA || '-' || :NEW.CDFUNC || ']' ||
                V_IDINTERRECPRES ||
                V_IDENVEMAILINTFA ||
                '';

      V_IDTIPOOPER := '1';
      V_ITPESQ     := :NEW.CDCLIENTE;

   ELSE
      IF :OLD.IDSTINTECLIE = 'A' OR :OLD.IDSTINTECLIE IS NULL THEN
         V_IDSTINTECLIE := '[Sit.ATIVO]';
      ELSE
         IF :OLD.IDSTINTECLIE = 'D' THEN
            V_IDSTINTECLIE := '[Sit.INATIVO]';
         END IF;
      END IF;

      IF :OLD.IDTPINTECLIE = 'P' THEN
         V_IDTPINTECLIE := '[PRESIDENTE]';
      ELSE
         IF :OLD.IDTPINTECLIE = 'D' THEN
            V_IDTPINTECLIE := '[DIRETOR]';
         ELSE
            IF :OLD.IDTPINTECLIE = 'G' THEN
               V_IDTPINTECLIE := '[GERENTE]';
            ELSE
               IF :OLD.IDTPINTECLIE = 'F' THEN
                  V_IDTPINTECLIE := '[FUNCIONRIO]';
               ELSE
                  IF :OLD.IDTPINTECLIE = 'O' THEN
                     V_IDTPINTECLIE := '[OUTROS]';
                  ELSE
                     IF :OLD.IDTPINTECLIE = 'S' THEN
                        V_IDTPINTECLIE := '[SUPERVISOR]';
                     ELSE
                        IF :OLD.IDTPINTECLIE = 'C' THEN
                           V_IDTPINTECLIE := '[COLABORADOR TEKNISA]';
                        ELSE
                           IF :OLD.IDTPINTECLIE = 'I' THEN
                              V_IDTPINTECLIE := '[SUPERINTENDENTE]';
                           ELSE
                              IF :OLD.IDTPINTECLIE = 'R' THEN
                                 V_IDTPINTECLIE := '[PROPRIETRIO]';
                              ELSE
                                 IF :OLD.IDTPINTECLIE = 'N' THEN
                                    V_IDTPINTECLIE := '[COORDENADOR]';
                                 END IF;
                              END IF;
                           END IF;
                        END IF;
                     END IF;
                  END IF;
               END IF;
            END IF;
         END IF;
      END IF;

      IF :OLD.IDENDEINCLIE = 'C' OR :OLD.IDENDEINCLIE IS NULL THEN
         V_IDENDEINCLIE := '[End.Comercial]';
      ELSE
         IF :OLD.IDENDEINCLIE = 'R' THEN
            V_IDENDEINCLIE := '[End.Residencial]';
         END IF;
      END IF;

      IF :OLD.IDINTERRECPRES = 'S' THEN
         V_IDINTERRECPRES := '[Presente: Sim]';
      ELSE
         IF :OLD.IDTPINTECLIE = 'R' THEN
            V_IDINTERRECPRES := '[Presente: No]';
         END IF;
      END IF;

      IF :OLD.IDENVEMAILINTFA = 'S' THEN
         V_IDENVEMAILINTFA := '[Email fat.atend.: Sim]';
      ELSE
         IF :OLD.IDTPINTECLIE = 'R' THEN
            V_IDENVEMAILINTFA := '[Email fat.atend.: No]';
         END IF;
      END IF;

      IF UPDATING THEN
         V_DESC := '[Cliente:' || V_NRINSJURCLIE || ' ' || V_NMFANTCLIE   || ']';

         V_DESC := V_DESC || '[Interloc:' || :OLD.CDINTECLIE || '-' ||:OLD.NMINTECLIE || ']';

         IF NVL(:OLD.IDSTINTECLIE, 'X') <> NVL(:NEW.IDSTINTECLIE, 'X') THEN
            V_DESC := V_DESC || V_IDSTINTECLIE || ']';
         END IF;

         IF NVL(:OLD.CDCARGOINTERLOC, 'X') <> NVL(:NEW.CDCARGOINTERLOC, 'X') THEN
            V_DESC := V_DESC || '[Cargo: ' || :OLD.CDCARGOINTERLOC || ']';
         END IF;

         IF NVL(:OLD.IDTPINTECLIE, 'X') <> NVL(:NEW.IDTPINTECLIE, 'X') THEN
            V_DESC := V_DESC ||  V_IDTPINTECLIE;
         END IF;

         IF NVL(:OLD.IDENDEINCLIE, 'X') <>  NVL(:NEW.IDENDEINCLIE, 'X') THEN
            V_DESC := V_DESC || V_IDENDEINCLIE;
         END IF;

         IF NVL(:OLD.DSENDEINCLIE, 'X') <> NVL(:NEW.DSENDEINCLIE, 'X') THEN
            V_DESC := V_DESC || '[End:' || :OLD.DSENDEINCLIE || ']';
         END IF;

         IF NVL(:OLD.NMBAIRINCLIE, 'X') <> NVL(:NEW.NMBAIRINCLIE, 'X') THEN
            V_DESC := V_DESC || '[Bairro:' || :OLD.NMBAIRINCLIE || ']';
         END IF;

         IF NVL(:OLD.NRCEPINCLIE, 'X') <> NVL(:NEW.NRCEPINCLIE, 'X') THEN
            V_DESC := V_DESC || '[CEP:' || :OLD.NRCEPINCLIE || ']';
         END IF;

         IF NVL(:OLD.CDPAIS, 'X') <> NVL(:NEW.CDPAIS, 'X') THEN
            V_DESC := V_DESC || '[Pas:' || :OLD.CDPAIS || ']';
         END IF;

         IF NVL(:OLD.SGESTADO, 'X') <> NVL(:NEW.SGESTADO, 'X') THEN
            V_DESC := V_DESC || '[Estado:' || :OLD.SGESTADO || ']';
         END IF;

         IF NVL(:OLD.CDMUNICIPIO, 'X') <> NVL(:NEW.CDMUNICIPIO, 'X') THEN
            V_DESC := V_DESC || '[Municpio:' || :OLD.CDMUNICIPIO || ']';
         END IF;

         IF NVL(:OLD.DTNASCINCLIE, sysdate) <> NVL(:NEW.DTNASCINCLIE, sysdate) THEN
            V_DESC := V_DESC || '[Nasc:' || TO_CHAR(:OLD.DTNASCINCLIE, 'FMDS') || ']';
         END IF;

         IF NVL(:OLD.NRTEL1INCLIE, 'X') <> NVL(:NEW.NRTEL1INCLIE, 'X') THEN
            V_DESC := V_DESC || '[Tell:' || :OLD.NRTEL1INCLIE || ']';
         END IF;

         IF NVL(:OLD.NRRAM1INCLIE, 'X') <> NVL(:NEW.NRRAM1INCLIE, 'X') THEN
            V_DESC := V_DESC || '[Ramal1:' || :OLD.NRRAM1INCLIE || ']';
         END IF;

         IF NVL(:OLD.NRTEL2INCLIE, 'X') <> NVL(:NEW.NRTEL2INCLIE, 'X') THEN
            V_DESC := V_DESC || '[Tel2:' || :OLD.NRTEL2INCLIE || ']';
         END IF;

         IF NVL(:OLD.NRRAM2INCLIE, 'X') <> NVL(:NEW.NRRAM2INCLIE, 'X') THEN
            V_DESC := V_DESC || '[Ramal2:' || :OLD.NRRAM2INCLIE || ']';
         END IF;

         IF NVL(:OLD.NRFAXINCLIE, 'X') <> NVL(:NEW.NRFAXINCLIE, 'X') THEN
            V_DESC := V_DESC || '[Fax:' || :OLD.NRFAXINCLIE || ']';
         END IF;

         IF NVL(:OLD.NRCELULINCLI, 'X') <> NVL(:NEW.NRCELULINCLI, 'X') THEN
            V_DESC := V_DESC || '[Cel:' || :OLD.NRCELULINCLI || ']';
         END IF;

         IF NVL(:OLD.NRTELREINCLI, 'X') <> NVL(:NEW.NRTELREINCLI, 'X') THEN
            V_DESC := V_DESC || '[Resid.:' || :OLD.NRTELREINCLI || ']';
         END IF;

         IF NVL(:OLD.DSEMAILICLIE, 'X') <> NVL(:NEW.DSEMAILICLIE, 'X') THEN
            V_DESC := V_DESC || '[Email:' || :OLD.DSEMAILICLIE || ']';
         END IF;

         IF NVL(:OLD.CDEMPRESA, 'X') || NVL(:OLD.CDFUNC, 'X') <> NVL(:NEW.CDEMPRESA, 'X') || NVL(:NEW.CDFUNC, 'X')  THEN
            V_DESC := V_DESC || '[Func.: ' || :OLD.CDEMPRESA || '-' || :OLD.CDFUNC || ']';
         END IF;

         IF NVL(:OLD.IDINTERRECPRES, 'X') <> NVL(:NEW.IDINTERRECPRES, 'X') THEN
            V_DESC := V_DESC || V_IDINTERRECPRES;
         END IF;

         IF NVL(:OLD.IDENVEMAILINTFA, 'X') <> NVL(:NEW.IDENVEMAILINTFA, 'X') THEN
            V_DESC := V_DESC || V_IDENVEMAILINTFA;
         END IF;

         V_IDTIPOOPER := '2';
         V_ITPESQ := :OLD.CDCLIENTE;
      ELSE
         IF DELETING THEN
            V_DESC := '[Cliente:' || V_NRINSJURCLIE || ' ' || V_NMFANTCLIE   || ']';
            V_DESC := V_DESC || '[Interlocutor:' || :OLD.CDINTECLIE || '-' ||:OLD.NMINTECLIE || ']' || V_IDSTINTECLIE;

            V_IDTIPOOPER := '3';
            V_ITPESQ     := :OLD.CDCLIENTE;
         END IF;
      END IF;
   END IF;

   IF NOT (V_DESC IS NULL) THEN
      V_DESC := SUBSTR(V_DESC, 1, 400);

      INSERT INTO LOGOPERA
         (NMTABELA, DTOPERACAO, NMRESPOPER,
          IDTIPOOPER,   DSOPERACAO, CDPESQITEM,
          DSRDMUSUOPER, DSENDUSUOPER, DSNMUSUOPER,
          DSMETUSUOPER, CDORESPOPER)
      VALUES
         ('INTECLIE', SYSDATE, NVL(V_NMOPERADOR, ' '),
           V_IDTIPOOPER, V_DESC, V_ITPESQ,
           V_DSSERVERRDM, V_DSREMOTEADDR, V_DSREMOTEHOST,
           V_DSSERVMETHOD, V_DSREMOTEOPER);
   END IF;
END;
/

-- VERSAO --
BEGIN ATUVEROBJ('LOG_GER_INTECLIE','0.00.000'); END;
/
