CREATE OR REPLACE PROCEDURE CTB_DFE_AJUSTE(
   P_CDFILIAL FILIAL.CDFILIAL%TYPE,
   P_NRLANCTONF NOTAFISCAL.NRLANCTONF%TYPE,
   P_NRSEQVENPAG CONTAPAGAR.NRSEQVENPAG%TYPE,
   P_NRPARCELAPAG CONTAPAGAR.NRPARCELAPAG%TYPE,
   P_NRLANCCTB OUT LANCCONT.NRLANCCONT%TYPE)
AS
   V_CDCONTCTBL CONTCTBL.CDCONTCTBL%TYPE;
   V_LIXO VARCHAR2(50); /* Varivel usada para pegar os parmetros OUT da procedure CONTCTBL_FILIAL. Esta procedure foi reaproveitada. */
   V_COUNTERRO INT;
   V_IDCOME VARCHAR2(01);
   V_IDCCUS VARCHAR2(01);
   V_IDCONTCCUS VARCHAR2(01);
   V_CDCOMERCIAL VARCHAR2(21);
   V_IDCONDESBONFORN VARCHAR(01);
   V_CDHISTPADR VARCHAR2(04);
   V_VRDESCBONI NUMBER;
   V_IDCONTAJUDTCOMP VARCHAR2(01);
   V_CDTPCTPAGAR VARCHAR2(06);
   V_DSCONTA VARCHAR2(200);
   V_PESSOAFORMATADO VARCHAR2(50);
   V_CDTPCTRECEB VARCHAR2(06);
   V_CDCLASSFINA VARCHAR2(06);
   V_SEQPARTIDA NUMBER;
   V_NRLANCTEMP VARCHAR2(20);
   V_DSHISTLANC VARCHAR2(200);
   V_DTLANC DATE;
   V_CDFILIAL VARCHAR2(04);
   PROCEDURE PARTIDA(P_CDEMPRESA IN VARCHAR2,
                     P_NRLANCTEMP IN VARCHAR2,
                     P_NRNOTAFISC IN VARCHAR2,
                     P_CDCONTCTBL IN VARCHAR2,
                     P_CDHISTPADR IN VARCHAR2,
                     P_DSHISTLANC IN VARCHAR2,
                     P_DTLANC IN DATE,
                     P_VRPARTIDA IN NUMBER,
                     P_IDCOME IN VARCHAR2,
                     P_CDCOMERCIAL IN VARCHAR2,
                     P_IDSISTEMA IN VARCHAR2,
                     P_IDCONTCCUS IN VARCHAR2,
                     P_IDCCUS IN VARCHAR2,
                     P_CDFILIALR IN VARCHAR2)
   AS
      V_COUNT NUMBER;
      V_CDCENTCUST VARCHAR2(04);
   BEGIN
      /* VERIFICA SE J EXISTE PARTIDA PARA O FORNECEDOR */
      BEGIN
         SELECT COUNT(*)
           INTO V_COUNT
           FROM LANCCTBTEMP
          WHERE NRLANCCTBTEMP = P_NRLANCTEMP
            AND CDEMPRESA = P_CDEMPRESA
            AND CDCONTCTBL = P_CDCONTCTBL;
      EXCEPTION
         WHEN NO_DATA_FOUND THEN
            V_COUNT := 0;
      END;
      IF V_COUNT = 0 THEN
         V_SEQPARTIDA := V_SEQPARTIDA + 1;
         INSERT INTO LANCCTBTEMP
            (CDEMPRESA, NRLANCCTBTEMP, CDDOCUTEMP, NRSEQCTBTEMP, CDCONTCTBL, CDHISTPADR,
             DSHISTCTB, DTLANCCTBTEMP, VRLANCCTBTEMP, IDLANCCTBCOME, CDLANCCTBCOME, IDSISTEMA)
         VALUES
            (P_CDEMPRESA, P_NRLANCTEMP, P_NRNOTAFISC, LPAD(TO_CHAR(V_SEQPARTIDA),5,'0'), P_CDCONTCTBL, P_CDHISTPADR,
             P_DSHISTLANC, P_DTLANC, P_VRPARTIDA, P_IDCOME, P_CDCOMERCIAL, P_IDSISTEMA);
         IF P_IDCONTCCUS = 'S' THEN
            IF P_IDCCUS <> 'O' THEN
               V_CDCENTCUST := BUSCA_CCUSTO(P_CDFILIALR, P_CDEMPRESA);
               INSERT INTO RATECTBTEMP
                  (CDEMPRESA, NRLANCCTBTEMP, NRSEQCTBTEMP, CDFILIAL, CDCENTCUST, VRRATECTBTEMP, DTCOMPCTBTEMP, NRSEQRATTEMP)
               VALUES
                  (P_CDEMPRESA, P_NRLANCTEMP, LPAD(TO_CHAR(V_SEQPARTIDA),5,'0'), P_CDFILIALR, V_CDCENTCUST,
                    P_VRPARTIDA, P_DTLANC, '00000');
            END IF;
         END IF;
      ELSE
         UPDATE LANCCTBTEMP
            SET VRLANCCTBTEMP = VRLANCCTBTEMP + (P_VRPARTIDA)
          WHERE CDEMPRESA = P_CDEMPRESA
            AND NRLANCCTBTEMP = P_NRLANCTEMP
            AND CDCONTCTBL = P_CDCONTCTBL;
         IF P_IDCONTCCUS = 'S' THEN
            IF V_IDCCUS <> 'O' THEN
               BEGIN
                  SELECT COUNT(*), TO_NUMBER(NRSEQCTBTEMP)
                    INTO V_COUNT, V_SEQPARTIDA
                    FROM LANCCTBTEMP
                   WHERE NRLANCCTBTEMP = P_NRLANCTEMP
                     AND CDEMPRESA = P_CDEMPRESA
                     AND CDCONTCTBL = P_CDCONTCTBL
                   group by NRSEQCTBTEMP;
               EXCEPTION
                  WHEN NO_DATA_FOUND THEN
                     V_COUNT := 0;
                     V_SEQPARTIDA := 0;
               END;
               V_CDCENTCUST := BUSCA_CCUSTO(P_CDFILIALR, P_CDEMPRESA);
               IF V_COUNT = 0 THEN
                  INSERT INTO RATECTBTEMP
                     (CDEMPRESA, NRLANCCTBTEMP, NRSEQCTBTEMP, CDFILIAL, CDCENTCUST, VRRATECTBTEMP, DTCOMPCTBTEMP, NRSEQRATTEMP)
                  VALUES
                     (P_CDEMPRESA, P_NRLANCTEMP, LPAD(TO_CHAR(V_SEQPARTIDA),5,'0'), P_CDFILIALR, V_CDCENTCUST,
                       P_VRPARTIDA, P_DTLANC, '00000');
               ELSE
                  UPDATE RATECTBTEMP
                     SET VRRATECTBTEMP = VRRATECTBTEMP + (P_VRPARTIDA)
                   WHERE NRLANCCTBTEMP = P_NRLANCTEMP
                     AND CDEMPRESA = P_CDEMPRESA
                     AND NRSEQCTBTEMP = LPAD(TO_CHAR(V_SEQPARTIDA),5,'0')
                     AND CDFILIAL = P_CDFILIALR
                     AND CDCENTCUST = V_CDCENTCUST;
               END IF;
            END IF;
         END IF;
      END IF;
   END;
BEGIN
   FOR NOTA IN
      (SELECT NF.CDFILIAL,      NF.NRLANCTONF,    NF.CDEMPRESA,
              NF.IDDOCFINANC,   NF.NRNOTAFISC,    NF.CDCLIENTE,
              NF.CDFORNECED,    NF.NRLANCTBDOC,   NF.VRNOTAFISC,
              NF.CDFILIEMIT,    NF.CDTIPOOPER,    TP.IDCONTABOPER,
              TP.IDOPERDEVONF,  NF.IDORIGDESTNF,  NF.VRPRODUTOS,
              NF.CDFILIRECE,    NF.DTENTRSAID,    NF.CDINSCESTA,
              NF.DTEMISSAO,     C.IDPRIPUBCLIE,   NF.IDENTRSAIDOP,
              NVL(FI.CDCENTCUST, EP.CDCENTCUST) AS CDCENTCUST,
              TP.CDTPCTPAGAR AS CDTPCTPAGOP, TP.CDTPCTRECEB AS CDTPCTRECOP,
              TC.CDCLASSFINA AS CDCLAFINOP, FO.DTINIVRPDESC, NF.CDSERIEENTR,
              NF.CDSERIE, NF.IDTPIJURNF, NF.NRINSJURNF, TP.IDDTCONTAB,
              TP.IDCOAVRIMPVRPROD
         FROM NOTAFISCAL NF, FILIAL FI, EMPRESA EP,
              TIPOOPERAC TP, TIPOCTPAGAR TC, FORNECEDOR FO, CLIENTE C
        WHERE NF.CDFILIAL     = P_CDFILIAL        AND
              NF.NRLANCTONF   = P_NRLANCTONF      AND
              NF.CDEMPRESA    = EP.CDEMPRESA      AND
              NF.IDENTRSAIDOP = TP.IDENTRSAIDOP   AND
              NF.CDTIPOOPER   = TP.CDTIPOOPER     AND
              TP.CDTPCTPAGAR  = TC.CDTPCTPAGAR(+) AND
              DECODE(NF.IDENTRSAIDOP,'E', NF.CDFILIRECE, NF.CDFILIEMIT) = FI.CDFILIAL AND
              NF.CDFORNECED   = FO.CDFORNECED(+)  AND
              NF.CDCLIENTE    = C.CDCLIENTE(+))LOOP
      BEGIN
         SELECT CDCONTFORCLI
           INTO V_CDCONTCTBL
           FROM TIPOOPERAC T
          WHERE CDTIPOOPER = NOTA.CDTIPOOPER
            AND IDENTRSAIDOP = NOTA.IDENTRSAIDOP;
      EXCEPTION
         WHEN NO_DATA_FOUND THEN
            V_CDCONTCTBL := NULL;
      END;

      BEGIN
        SELECT IDCONTGERE
          INTO V_IDCONTCCUS
          FROM CONTOPECTBL
         WHERE CDEMPRESA = NOTA.CDEMPRESA;
      EXCEPTION
         WHEN NO_DATA_FOUND THEN
            V_IDCONTCCUS := 'N';
      END;

      IF ((NOTA.IDORIGDESTNF IS NULL) OR (NOTA.IDORIGDESTNF = 'F')) THEN
         BEGIN
            SELECT CDCONTFORCLI, CDHISTPADR
              INTO V_CDCONTCTBL, V_CDHISTPADR
              FROM TIPOOPERAC T
             WHERE CDTIPOOPER = NOTA.CDTIPOOPER
               AND IDENTRSAIDOP = NOTA.IDENTRSAIDOP;
         EXCEPTION
            WHEN NO_DATA_FOUND THEN
               V_CDCONTCTBL := NULL;
               V_CDHISTPADR := NULL;
         END;
         IF V_CDCONTCTBL IS NULL THEN
            V_CDCONTCTBL := CTB_CCFORNECEDOR(NOTA.CDFORNECED, NOTA.CDFILIRECE, NOTA.CDEMPRESA);
         END IF;

      ELSIF (NOTA.IDORIGDESTNF = 'C') THEN
         IF V_CDCONTCTBL IS NULL THEN
            V_CDCONTCTBL := CTB_CCCLIENTE(NOTA.CDCLIENTE, NOTA.CDFILIEMIT, NOTA.CDEMPRESA);
         END IF;
      ELSE
         IF V_CDCONTCTBL IS NULL THEN
            CONTCTBL_FILIAL(NOTA.CDEMPRESA, NOTA.CDTIPOOPER, NOTA.IDENTRSAIDOP, NOTA.CDFILIRECE, V_CDCONTCTBL, V_LIXO, V_LIXO, V_LIXO);
         END IF;
      END IF;
      
      BEGIN
         SELECT DECODE(NOTA.IDORIGDESTNF, 'F', NOTA.CDFORNECED, DECODE(NOTA.IDORIGDESTNF, 'C', NOTA.CDCLIENTE, NULL))
           INTO V_CDCOMERCIAL
           FROM DUAL;
      EXCEPTION
         WHEN NO_DATA_FOUND THEN
            V_CDCOMERCIAL := NULL;
      END;

      FOR C_TPAJUSFORN IN
        (SELECT F.CDFORNECED,  F.CDAJUCTPAG, F.VRPEDESCFORN, F.IDTPDESCFORN,
                T.CDHISTPADR,  T.CDCONTCTBL, T.DSAJUCTPAG,   T.IDAJUCTPAG,
                H.DSHISTPADR, DTINIVRPDESC
           FROM FORNECEDOR F, TIPOAJPAGAR T, HISTPADR H
          WHERE (F.CDFORNECED   = NOTA.CDFORNECED)
            AND (NOT F.VRPEDESCFORN IS NULL)
            AND (F.IDTPDESCFORN = 'B')
            AND (T.CDAJUCTPAG = F.CDAJUCTPAG)
            AND (H.CDHISTPADR = T.CDHISTPADR)) LOOP

         BEGIN
            SELECT NVL(IDCONDESBONFORN,'S') IDCONDESBONFORN
              INTO V_IDCONDESBONFORN
              FROM PARAMFILIAL
             WHERE CDFILIAL = NOTA.CDFILIRECE;
         EXCEPTION
            WHEN NO_DATA_FOUND THEN
               V_IDCONDESBONFORN := NULL;
         END;

         IF V_IDCONDESBONFORN = 'S' THEN
            IF V_CDHISTPADR IS NULL THEN
               V_CDHISTPADR := C_TPAJUSFORN.CDHISTPADR;
            END IF;

            V_SEQPARTIDA := 0;
            FOR AJUSTE_CONTA IN
               (SELECT A.CDFILIAL, A.NRLANCTONF, A.NRSEQVENPAG, A.NRPARCELAPAG,
                       A.DTAJUSTEPAG, A.CDAJUCTPAG, A.DSAJUSTEPAG, A.VRAJUSTEPAG,
                       T.IDAJUCTPAG, C.DTATUAVENPAG, A.NRLCTBAJPAG
                 FROM AJCTPAGAR A, TIPOAJPAGAR T, CONTAPAGAR C
                 WHERE A.CDFILIAL   = P_CDFILIAL
                   AND A.NRLANCTONF = P_NRLANCTONF
                   AND A.NRSEQVENPAG = P_NRSEQVENPAG
                   AND A.NRPARCELAPAG = P_NRPARCELAPAG
                   AND A.CDFILIAL   = C.CDFILIAL
                   AND A.NRLANCTONF = C.NRLANCTONF
                   AND A.NRSEQVENPAG = C.NRSEQVENPAG
                   AND A.NRPARCELAPAG = C.NRPARCELAPAG
                   AND A.CDAJUCTPAG = T.CDAJUCTPAG) LOOP

               V_VRDESCBONI := AJUSTE_CONTA.VRAJUSTEPAG;

               BEGIN
                  SELECT NVL(IDCONTAJUDTCOMP, 'N') IDCONTAJUDTCOMP
                    INTO V_IDCONTAJUDTCOMP
                    FROM PARAMGERAL;
               EXCEPTION
                  WHEN NO_DATA_FOUND THEN
                     V_IDCONTAJUDTCOMP := NULL;
               END;

               CTB_DFE_HISTORICO(P_CDFILIAL, P_NRLANCTONF, V_CDHISTPADR, V_DSHISTLANC);
               BEGIN
                  SELECT MAX(DSCONTAPAG)
                    INTO V_DSCONTA
                    FROM CONTAPAGAR
                   WHERE CDFILIAL   = P_CDFILIAL
                     AND NRLANCTONF = P_NRLANCTONF
                     AND NRSEQVENPAG = P_NRSEQVENPAG
                     AND NRPARCELAPAG = P_NRPARCELAPAG;
               EXCEPTION
                  WHEN NO_DATA_FOUND THEN
                     V_DSCONTA := ' ';
               END;
               IF V_DSCONTA IS NULL THEN
                  IF (NOTA.NRNOTAFISC IS NOT NULL) AND (NOTA.CDSERIEENTR IS NOT NULL) THEN
                     V_PESSOAFORMATADO := FORMATA_PESSOA(NOTA.IDTPIJURNF, NOTA.NRINSJURNF);
                     V_DSCONTA := SUBSTR('NF:' || V_PESSOAFORMATADO || ' - ' || NOTA.NRNOTAFISC || ' - ' || NOTA.CDSERIEENTR, 1, 40);
                  ELSE
                     V_PESSOAFORMATADO := FORMATA_PESSOA(NOTA.IDTPIJURNF, NOTA.NRINSJURNF);
                     V_DSCONTA := SUBSTR('NF: ' || V_PESSOAFORMATADO || ' - ' || 'Seq: ' || NOTA.CDSERIEENTR, 1, 40);
                  END IF;
               END IF;

               V_DSHISTLANC := REPLACE(V_DSHISTLANC, '[DCP]', NVL(V_DSCONTA, ' '));
               V_DSHISTLANC := REPLACE(V_DSHISTLANC, '[TCP]', NVL(AJUSTE_CONTA.CDAJUCTPAG, ' '));
               V_DSHISTLANC := REPLACE(V_DSHISTLANC, '[TAP]', NVL(C_TPAJUSFORN.DSAJUCTPAG, ' '));
               V_DSHISTLANC := REPLACE(V_DSHISTLANC, '[DAP]', ' ');

               BEGIN
                  SELECT DECODE(NOTA.IDENTRSAIDOP, 'E', NOTA.CDFILIRECE, NOTA.CDFILIEMIT)
                    INTO V_CDFILIAL
                    FROM DUAL;
               EXCEPTION
                  WHEN NO_DATA_FOUND THEN
                     V_CDFILIAL := NULL;
               END;

               V_NRLANCTEMP := NULL;
               V_NRLANCTEMP := AJUSTE_CONTA.NRLCTBAJPAG;

               IF V_NRLANCTEMP IS NULL THEN
                  /* PEGA UM NOVO NMERO DE LANAMENTO CONTBIL, CASO O LANAMENTO NO PAG SEJA NOVO */
                  IF V_IDCONTAJUDTCOMP = 'S' THEN
                     IF NOTA.IDENTRSAIDOP = 'E' THEN
                        NOVO_CODIGO_NT('LANCCONTABIL' || NOTA.CDEMPRESA || TO_CHAR(NOTA.DTENTRSAID,'YYYYMM'), V_NRLANCTEMP);
                        V_NRLANCTEMP := TO_CHAR(NOTA.DTENTRSAID,'YYYYMM')||SUBSTR(V_NRLANCTEMP, 15, 6);
                        V_DTLANC := NOTA.DTENTRSAID;
                     ELSE
                        NOVO_CODIGO_NT('LANCCONTABIL' || NOTA.CDEMPRESA || TO_CHAR(NOTA.DTEMISSAO,'YYYYMM'), V_NRLANCTEMP);
                        V_DTLANC := NOTA.DTEMISSAO;
                        V_NRLANCTEMP := TO_CHAR(NOTA.DTENTRSAID,'YYYYMM')||SUBSTR(V_NRLANCTEMP, 15, 6);
                     END IF;
                  ELSE
                      NOVO_CODIGO_NT('LANCCONTABIL' || NOTA.CDEMPRESA || TO_CHAR(AJUSTE_CONTA.DTATUAVENPAG,'YYYYMM'), V_NRLANCTEMP);
                      V_NRLANCTEMP := TO_CHAR(NOTA.DTENTRSAID,'YYYYMM')||SUBSTR(V_NRLANCTEMP, 15, 6);
                      V_DTLANC := AJUSTE_CONTA.DTATUAVENPAG;
                  END IF;
               END IF;
               
               V_SEQPARTIDA := 0;
               /* AJUSTE DO TIPO DESCONTO */
               IF AJUSTE_CONTA.IDAJUCTPAG = 'D' THEN
                  /* PARTIDA DO CLIENTE/ FORNECEDOR */
                  BUSCA_TPCOMERCIAL(C_TPAJUSFORN.CDCONTCTBL, V_IDCOME, V_IDCCUS);
                  PARTIDA(NOTA.CDEMPRESA,
                          V_NRLANCTEMP,
                          NOTA.NRNOTAFISC,
                          V_CDCONTCTBL,
                          V_CDHISTPADR,
                          V_DSHISTLANC,
                          V_DTLANC,
                          V_VRDESCBONI * -1,
                          V_IDCOME,
                          V_CDCOMERCIAL,
                          'DFE',
                          V_IDCONTCCUS,
                          V_IDCCUS,
                          V_CDFILIAL);

                  /* PARTIDA DO AJUSTE */
                  BUSCA_TPCOMERCIAL(C_TPAJUSFORN.CDCONTCTBL, V_IDCOME, V_IDCCUS);
                  PARTIDA(NOTA.CDEMPRESA,
                          V_NRLANCTEMP,
                          NOTA.NRNOTAFISC,
                          C_TPAJUSFORN.CDCONTCTBL,
                          V_CDHISTPADR,
                          V_DSHISTLANC,
                          V_DTLANC,
                          V_VRDESCBONI,
                          V_IDCOME,
                          V_CDCOMERCIAL,
                          'DFE',
                          V_IDCONTCCUS,
                          V_IDCCUS,
                          V_CDFILIAL);
               ELSIF AJUSTE_CONTA.IDAJUCTPAG = 'A' THEN
                  /* PARTIDA DO CLIENTE/ FORNECEDOR */
                  BUSCA_TPCOMERCIAL(C_TPAJUSFORN.CDCONTCTBL, V_IDCOME, V_IDCCUS);
                  PARTIDA(NOTA.CDEMPRESA,
                          V_NRLANCTEMP,
                          NOTA.NRNOTAFISC,
                          V_CDCONTCTBL,
                          V_CDHISTPADR,
                          V_DSHISTLANC,
                          V_DTLANC,
                          V_VRDESCBONI,
                          V_IDCOME,
                          V_CDCOMERCIAL,
                          'DFE',
                          V_IDCONTCCUS,
                          V_IDCCUS,
                          V_CDFILIAL);

                  /* PARTIDA DO AJUSTE */
                  BUSCA_TPCOMERCIAL(C_TPAJUSFORN.CDCONTCTBL, V_IDCOME, V_IDCCUS);
                  PARTIDA(NOTA.CDEMPRESA,
                          V_NRLANCTEMP,
                          NOTA.NRNOTAFISC,
                          C_TPAJUSFORN.CDCONTCTBL,
                          V_CDHISTPADR,
                          V_DSHISTLANC,
                          V_DTLANC,
                          V_VRDESCBONI * -1,
                          V_IDCOME,
                          V_CDCOMERCIAL,
                          'DFE',
                          V_IDCONTCCUS,
                          V_IDCCUS,
                          V_CDFILIAL);
               END IF;
               /* VERIFICACAO DE ERROS NAS PARTIDAS E NO LANCAMENTO CONTABIL*/
               VERIFICA_ERRO_CTB(V_NRLANCTEMP, NOTA.CDEMPRESA);
               BEGIN
                  SELECT COUNT(*)
                    INTO V_COUNTERRO
                    FROM ERROCTBTEMP
                   WHERE NRLANCCTBTEMP = V_NRLANCTEMP
                     AND CDEMPRESA = NOTA.CDEMPRESA;
               EXCEPTION
                  WHEN NO_DATA_FOUND THEN
                     V_COUNTERRO := 0;
               END;

               /* CASO NO TENHA GERADO ERRO NA ROTINA DE CONTABILIZAO, O NMERO DE LANAMENTO  GRAVADO NA NOTAFISCAL. */
               IF V_COUNTERRO = 0 THEN
                  UPDATE AJCTPAGAR
                     SET NRLCTBAJPAG = V_NRLANCTEMP
                   WHERE CDFILIAL = P_CDFILIAL
                     AND NRLANCTONF = P_NRLANCTONF
                     AND NRSEQVENPAG = P_NRSEQVENPAG
                     AND NRPARCELAPAG = P_NRPARCELAPAG
                     AND CDAJUCTPAG = C_TPAJUSFORN.CDAJUCTPAG
                     AND DTAJUSTEPAG = AJUSTE_CONTA.DTAJUSTEPAG;
               ELSE
                  EXIT;
               END IF;
               P_NRLANCCTB := V_NRLANCTEMP;

               /* TRMINO DAS PARTIDAS DO LANCAMENTO CONTABIL*/
                /* GRAVA O LANAMENTO TEMPORRIO SE NO CONTER ERRO NA LANCCONT E LANCCUSTO, APS GRAVAR IR APAGAR O LANCAMENTO TEMPORRIO */
               GRAVA_LANC_CTB(V_NRLANCTEMP, NOTA.CDEMPRESA);
            END LOOP;
         END IF;
      END LOOP;
   END LOOP;
END;
/
